/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   PAD.h
 * Author: Maxi
 *
 * Created on 12. November 2018, 15:10
 */

#ifndef PAD_H
#define PAD_H

#include "SATELLITE.h"
#include "GNSSParameters.h"
#include "enumSatelliteSystems.h"
#include "SatelliteLoop.h"
#include <iostream>
#include <fstream>
#include <vector>
#include <iomanip>//std::setprecision

class PAD {
//in order to access the attributes without getter and setter    
//friend class DECODE;

public:
    PAD();
    PAD(const PAD& orig);
    virtual ~PAD();
    void writeInCsv(std::ofstream &streamData, int &iType);
    void writeInKml(std::ofstream &streamData, int &iModus);
    void readOfFile(char** pc, bool *bSuccess);
    int getVectorSize();
    void clearVector();
    void chosenSatSys(bool &refbGPS, bool &refbEGNOS, bool &refbGLONASS,bool &refbGALILEO);
    void resetPointers();
    unsigned short getResultCode();
    
private:
    //Dynamic attributes+ Satellite attributes
    /*
    std::vector<SATELLITE> vecSatellite;//=vecSatellite.reserve(30*18);
    SATELLITE *pSatellite=new SATELLITE;
    
    int iAmountGPS;
    int iAmountEGNOS;
    int iAmountGLO;
    int iAmountGAL;
    int iAmountBEI;
    enumSatelliteSystems currentSatSys;
    enumSatelliteSystems thisSatSys;
    */
    int iNumPotentialSat;
    bool arraybSatSys[4];
    
    SatelliteLoop *pSatelliteLoop=new SatelliteLoop;
    
    //Consistent attributes
    unsigned char id;
    unsigned short resCode;
    unsigned short week;
    double tow;
    unsigned short weeklnit;
    unsigned short towlnit;
    //short reserve1;
    double lat;
    double lon;
    double height;
    double ECEFX;
    double ECEFY;
    double ECEFZ;
    double b[3];
    double bStdDev[3];
    double vel[3];
    double velStdDev[3];
    double acc[3];
    double accStdDev[3];
    double att[3];
    double attStdDev[3];
    double accuracy;
    //double reserve2;
    double timinginfo[5];
    //double reserve3[5];
    double gnssReception;
    unsigned char numSats;
    unsigned char numRcv;
    
    //Methods private
    //void reserveVector();
    //void fillVector();
    //void completeAmountListBeginning(enumSatelliteSystems &SatSys);
    //void completeAmountListEnding(enumSatelliteSystems &SatSys);
    //void assignSatSys(enumSatelliteSystems &SatSys, int iconstexpres);
    //void assignAmountGNSS(enumSatelliteSystems &SatSys, int i);
};

#endif /* PAD_H */

